<template>
    <CModal
        :show="show"
        centered
        color="primary"
        size="lg"
        @update:show="updateShow($event)"
    >
        <template #header>
            <div>
                <div class="font-weight-bold font-2xl">
                    Настройка таблицы
                </div>
                Выберите столбцы, которые хотите показать или скрыть
            </div>
        </template>
        <div class="py-3">
            <CRow>
                <CCol>
                    <CButton @click="toggleAll(true)" color="ghost">Показать все</CButton>
                    <CButton @click="toggleAll(false)" color="ghost">Скрыть все</CButton>
                </CCol>
            </CRow>
            <div style="columns: 2">
                <div
                    v-for="(field, index) in formFields"
                    :key="index"
                >
                    <q-checkbox
                        v-model="visibleFields"
                        :val="field.name"
                        :label="field.label"
                    />
                </div>
            </div>
            <CRow>
                <CCol>
                </CCol>
            </CRow>
        </div>
        <template #footer>
            <CButton type="success" @click="saveChanges">Сохранить</CButton>
        </template>
    </CModal>
</template>

<script>
export default {
    name: 'ColumnVisibilityPanel',
    props: {
        show: Boolean // Отображение панели
    },
    data() {
        return {
            formFields: [],
            visibleFields: []
        }
    },
    watch: {
        'show': {
            handler: function() {
                this.refreshFieldsData()
            },
            deep: true
        }
    },
    methods: {
        updateShow(value) {
            this.$emit('update:show', value)
        },
        saveChanges() {
            this.$store.dispatch('saveColumns', this.visibleFields)
            this.updateShow(false)
        },
        refreshFieldsData() {
            this.formFields = JSON.parse(JSON.stringify(this.$store.getters.orderCreateHideableColumns))
            this.visibleFields = JSON.parse(JSON.stringify(this.$store.getters.getVisibleFields))
        },
        toggleAll(value) {
            if (value) {
                this.visibleFields = JSON.parse(JSON.stringify(this.$store.getters.orderCreateHideableColumns)).map(item => item.name)
            } else {
                this.visibleFields = JSON.parse(JSON.stringify(this.$store.getters.orderCreateRequiredColumns)).map(item => item.name)
            }
        }
    },
}
</script>
